 gui = require('Gspot')
 serialize = require 'ser'
 socket = require("socket")
 Wins = 0
 Loses = 0
 power = 1
 Menu = true
 Mode = 0
function saveGame()
    local data = {} -- Make a table to store variables in.

    data.Wins = Wins
    data.Loses = Loses
    data.power = power

    -- Save the table to the "savegame.txt" file:
    love.filesystem.write("savegame.txt", serialize(data))
end

function loadGame() 
    -- Do not load the game if the "savegame.txt" file doesn't exist:
    if not love.filesystem.exists("savegame.txt") then
        return
    end

    -- Load the data table:
    local data = love.filesystem.load("savegame.txt")()

    -- Copy the variables out of the table:
    Wins = data.Wins
    Loses = data.Loses
    power = data.power
end

function startGame(mode)
	Winner = ""
	if world ~= nil then world:destroy() end
	  world = love.physics.newWorld(0, 9.81*64, true)
	      	width = love.graphics.getWidth( )
  love.physics.setMeter(64)
	  objects = {}
	  allBullets = {}
	objects.ground = {}
  objects.ground.body = love.physics.newBody(world, width/2, love.graphics.getHeight()-50/2)
  objects.ground.shape = love.physics.newRectangleShape(love.graphics.getWidth() + 800, 50)
  objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape);

  --let's create a ball
  objects.ball = {}
  objects.ball.body = love.physics.newBody(world, 50, 650/2, "dynamic")
  objects.ball.shape = love.physics.newCircleShape(20)
  objects.ball.fixture = love.physics.newFixture(objects.ball.body, objects.ball.shape, 1)
  objects.ball.fixture:setRestitution(0.15)

  objects.ball2 = {}
  objects.ball2.body = love.physics.newBody(world, width - 50, 650/2, "dynamic")
  objects.ball2.shape = love.physics.newCircleShape(20)
  objects.ball2.fixture = love.physics.newFixture(objects.ball2.body, objects.ball2.shape, 1)
  objects.ball2.fixture:setRestitution(0.15)

  objects.wall2 = {}
  objects.wall2.body = love.physics.newBody(world, love.graphics.getWidth(), 170, "static")
  objects.wall2.shape = love.physics.newRectangleShape(0, 0, 100, 1000)
  objects.wall2.fixture = love.physics.newFixture(objects.wall2.body, objects.wall2.shape, 5)
 
  objects.wall1 = {}
  objects.wall1.body = love.physics.newBody(world, 0,170, "static")
  objects.wall1.shape = love.physics.newRectangleShape(0, 0, 100, 1000)
  objects.wall1.fixture = love.physics.newFixture(objects.wall1.body, objects.wall1.shape, 5)
  guiG:hide()
  Menu = false
  Mode = mode
end

function drawnorm()
    love.graphics.setColor(72, 160, 14)
  love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints()))

  love.graphics.setColor(193, 47, 14)
  love.graphics.circle("fill", objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.shape:getRadius())
  
  love.graphics.setColor(14, 47, 193)
  love.graphics.circle("fill", objects.ball2.body:getX(), objects.ball2.body:getY(), objects.ball2.shape:getRadius())

  love.graphics.setColor(50, 50, 50)
  love.graphics.polygon("fill", objects.wall2.body:getWorldPoints(objects.wall2.shape:getPoints()))
  love.graphics.polygon("fill", objects.wall1.body:getWorldPoints(objects.wall1.shape:getPoints()))
end

function drawninvis()
  love.graphics.setColor(72, 160, 14)
  love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints()))

  love.graphics.setColor(50, 50, 50)
  love.graphics.polygon("fill", objects.wall2.body:getWorldPoints(objects.wall2.shape:getPoints()))
  love.graphics.polygon("fill", objects.wall1.body:getWorldPoints(objects.wall1.shape:getPoints()))
end

function endGame()
	Menu = true
	--`objects = {}
	guiG:show()
	allBullets = {}
end

function love.load()
    Winner = ""
	loadGame()
    udp = socket.udp()
	WLratio = Wins / Loses * 100
	guiG = gui:group(false, {0, 0, 0, 0})
    love.window.setFullscreen(true, 'desktop')
    LastWinner = gui:text("Last Winner: ", {love.graphics.getWidth() / 2 - (496/2), love.graphics.getHeight() - 86, 496, 64}, guiG)
    LastWinner.style.font = love.graphics.newFont(40)
	exitb = gui:text("", {love.graphics.getWidth() - 40, 10, 50, 50}, guiG)
	exitb.style.default = {255, 255, 255}
	exit = gui:button("X", {love.graphics.getWidth()-60, 0, 60, 60}, guiG)
    exit.style.default = {239, 69, 69}
    exit.style.hilite = {239, 69, 69}
    exit.style.focus = {183, 55, 55}
    exit.style.font = love.graphics.newFont(60)
	Gamemodes = gui:text('Gamemodes', {love.graphics.getWidth() / 2 - 128, 80, 200, 200}, guiG)
	Gamemodes.style.font = love.graphics.newFont(30)
	underline = gui:text("__________________", {love.graphics.getWidth() / 2 - 130, 85, 250, 200}, guiG)
		underline.style.font = love.graphics.newFont(30)
  button = gui:button('Local', {love.graphics.getWidth() / 2 - 128, 128, 256, 64}, guiG)
  button.style.default = {98, 136, 248}
  button.style.hilite = {98, 136, 248}
    button.style.focus = {54, 136, 248}
  button.style.font = love.graphics.newFont(60)
  button:setshape("rect")
    button3 = gui:button('Invisible', {love.graphics.getWidth() / 2 - 128, 256 + 64, 256, 64}, guiG)
  button3.style.default = {98, 136, 248}
  button3.style.hilite = {98, 136, 248}
    button3.style.focus = {54, 136, 248}
  button3.style.font = love.graphics.newFont(50)
  button3:setshape("rect")
      button4 = gui:button('No Powers', {love.graphics.getWidth() / 2 - 128, 256 + 168, 256, 64}, guiG)
  button4.style.default = {98, 136, 248}
  button4.style.hilite = {98, 136, 248}
    button4.style.focus = {54, 136, 248}
  button4.style.font = love.graphics.newFont(50)
  button4:setshape("rect")
  button2 = gui:button('Online', {love.graphics.getWidth() / 2 - 128, 222, 256, 64}, guiG)
  button2.style.default = {98, 136, 248}
  button2.style.hilite = {98, 136, 248}
    button2.style.focus = {54, 136, 248}
  button2.style.font = love.graphics.newFont(60)
  button2:setshape("rect")
  exit:setshape("rect")
  button.click = function(this) startGame(0) end
  exit.click = function(this) love.event.quit() saveGame() end
  button2.click = function(this) gui:feedback("coming soon") end
  button3.click = function(this) startGame(2)end
  button4.click = function(this) startGame(3)end
 
  --initial graphics setup
  love.graphics.setBackgroundColor(104, 136, 248)
end
 
 allBullets = {}

 function createbullet(x, y)
    bullet = {}
    bullet.body = love.physics.newBody(world, x, y, "dynamic")
    bullet.shape = love.physics.newCircleShape(10)
    bullet.fixture = love.physics.newFixture(bullet.body, bullet.shape, 1)
    bullet.fixture:setRestitution(1.25765)

    table.insert(allBullets, bullet)

    return bullet
 end

 b1d = 800
 b2d = -800
 b1e = 75
 b2e = 75
 cooldown1 = 0
 cooldown2 = 0
 cont1 = 0
cont2 = 0

 function blink(player)
x2 = objects.ball2.body:getX()
x1 = objects.ball.body:getX()
      if player == 1 and cooldown1 == 0 then
        objects.ball.body:setX(x1+b1d)
              cooldown1 = 1700
      end
      if player == 2 and cooldown2 == 0 then
        objects.ball2.body:setX(x2+b2d)
              cooldown2 = 1700
      end
 end

function freeze(target)
  if target == 1 and cooldown2 == 0 then
    cont1 = 500
    cooldown2 = 1700
  end
  if target == 2 and cooldown1 == 0 then
      cont2 = 500
      cooldown1 = 1700
    end
end

function love.update(dt)
    if cont1 ~= 0 then
    cont1 = cont1 - 1
end
  if Menu == false then
  world:update(dt)
end
  gui:update(dt)
  if Menu == true and Winner ~= "" then
    LastWinner.label = "Last Winner: "..Winner 
  end
  while table.getn(allBullets) > 100 do -- Keep deleting bullets until there are 100 or less.
     bulletToDelete = allBullets[1] -- Get the earliest bullet created.

        bulletToDelete.fixture:destroy() -- Destroy the bullet in the physics engine.
        bulletToDelete.body:destroy()

        table.remove(allBullets, 1) -- Delete the bullet from the allBullets list so that we don't try to draw it.
    end
    if Menu == false then
     distance1 = love.physics.getDistance(objects.wall1.fixture, objects.ball.fixture)

    if distance1 < 20 then
        objects.ball.body:applyForce(2000 * (1 - distance1 / 20), 0)
    end
         distance2 = love.physics.getDistance(objects.wall2.fixture, objects.ball.fixture)

    if distance2 < 20 then
        objects.ball.body:applyForce(-2000 * (1 - distance2 / 20), 0)
    end
         distance3 = love.physics.getDistance(objects.wall1.fixture, objects.ball2.fixture)

    if distance3 < 20 then
        objects.ball2.body:applyForce(2000 * (1 - distance3 / 20), 0)
    end
         distance4 = love.physics.getDistance(objects.wall2.fixture, objects.ball2.fixture)

    if distance4 < 20 then
        objects.ball2.body:applyForce(-2000 * (1 - distance4 / 20), 0)
    end
             distance5 = love.physics.getDistance(objects.ball.fixture, objects.ball2.fixture)

    if distance5 < 20 then
        objects.ball2.body:applyForce(0, 2000 * (1 - distance5 / 20))
               objects.ball.body:applyForce(0, 2000 * (1 - distance5 / 20))
    end
end
  --objects.wall1.body:setPosition(0,300)
    --objects.wall2.body:setPosition(love.graphics.getWidth(),300)
    --objects.wall1.body:setAngle(0)
        --objects.wall2.body:setAngle(0)
        if not love.keyboard.isDown("space") and not love.keyboard.isDown("m") and table.getn(allBullets) > 50 then
        	bulletToDelete = allBullets[1] -- Get the earliest bullet created.

        bulletToDelete.fixture:destroy() -- Destroy the bullet in the physics engine.
        bulletToDelete.body:destroy()

        table.remove(allBullets, 1)
        end
 
    --if love.keyboard.isDown("escape")then
    --	saveGame()
    --  love.event.quit()
    --end
    WLratio = (Wins / (Wins + Loses))* 100
    if Menu == false then
      if cooldown1 ~= 0 then
        cooldown1 = cooldown1 - 1
      end
        if cont2 ~= 0 then
    cont2 = cont2 - 1
end
            if cooldown2 ~= 0 then
        cooldown2 = cooldown2 - 1
      end
    	love.window.setTitle("BetaBashers")
    	    if objects.ball.body:getY() > love.graphics.getHeight() then
    	endGame()
    	Winner = "Player2"
    elseif objects.ball2.body:getY() > love.graphics.getHeight() then
    	endGame()
    	Winner = "Player1"
    end
    	if love.keyboard.isDown("d") and cont1 == 0 then
      b1d = 800
      b1e = 75
    objects.ball.body:applyForce(350, 0)
  end
  if love.keyboard.isDown("a") and cont1 == 0 then
    b1d = -800
    b1e = -75
    objects.ball.body:applyForce(-350, 0)
  end
  if love.keyboard.isDown("w") and cont1 == 0 then
    contacts1 = objects.ball.body:getContactList()

    if table.getn(contacts1) > 0 then
      objects.ball.body:applyForce(0, -1050)
    end
  end
        if love.keyboard.isDown('space') and Mode ~= 3 and cont1 == 0 then
      if power == 1 then
      local x, y = objects.ball.body:getPosition()
      bullet = createbullet(x + b1e, y)      
      bullet.body:setLinearVelocity(b1d, 0)
            elseif power == 2 then
      blink(1)
      elseif power == 3 then
        freeze(2)
    end
end

    if love.keyboard.isDown("right") and cont2 == 0 then
      b2d = 800
      b2e = -75
    objects.ball2.body:applyForce(350, 0)
  end
  if love.keyboard.isDown("left") and cont2 == 0 then
    b2d = -800
    b2e = 75
    objects.ball2.body:applyForce(-350, 0)
  end
  if love.keyboard.isDown("up") and cont2 == 0 then
    contacts2 = objects.ball2.body:getContactList()

    if table.getn(contacts2) > 0 then
      objects.ball2.body:applyForce(0, -1050)
    end
  end
    if love.keyboard.isDown('m') and Mode ~= 3 and cont2 == 0 then
      if power == 1 then
      local x, y = objects.ball2.body:getPosition()
      bullet = createbullet(x - b2e, y)
      bullet.body:setLinearVelocity(b2d, 0)
      elseif power == 2 then
      blink(2)
      elseif power == 3 then
        freeze(1)
    end
  end
    else
    	love.window.setTitle("BetaBashersLauncher")
    		allBullets = {}
    		objects = {}
        cooldown2 = 0
        cooldown1 = 0
        cont1 = 0
        cont2 = 0
  end
end


function love.draw()
  --love.graphics.print(cont2, 50, 50)
  --x, y = objects.ball2.body:getLinearVelocity()
  --love.graphics.print(y, 0, 0)

  --width = love.graphics.getWidth( )
  --love.graphics.print(width, 0, 0)
  if Menu == false then
    if Mode ~= 2 then
      drawnorm()
      elseif Mode == 2 then
      drawninvis()
      end
end
  for bulletIndex, bullet in pairs(allBullets) do
        love.graphics.setColor(255, 255, 255)
        love.graphics.circle("fill", bullet.body:getX(), bullet.body:getY(), bullet.shape:getRadius())
    end
gui:draw()
end
love.mousepressed = function(x, y, button)
  gui:mousepress(x, y, button)
end
love.mousereleased = function(x, y, button)
  gui:mouserelease(x, y, button)
end
love.wheelmoved = function(x, y)
  gui:mousewheel(x, y)
end